// component: ceilingLamp
ON INIT {
  SETNAME "Ceiling Lamp"
  SET_INTERACTIVITY NONE
  SET lightningWasCast 0
  SET oldIsOn -1
  SET isOn 0
  ACCEPT
}

ON INITEND {
  SET oldIsOn isOn

  if (isOn == 1) {
    TWEAK SKIN "[stone]_ground_caves_wet05" "backrooms-[metal]-light-on"
    PLAY -lip "fluorescent-lamp-hum" // [l] = loop, [i] = unique, [p] = variable pitch

    SET #BURNOUT_TIMER ~^RND_120~
    INC #BURNOUT_TIMER 30
    RANDOM 85 TIMERautooff 1 ~#BURNOUT_TIMER~ SENDEVENT OFF SELF ""
  } else {
    TWEAK SKIN "[stone]_ground_caves_wet05" "backrooms-[metal]-light-off"
  }

  ACCEPT
}

ON ON {
  SET isOn 1
  GOTO SWITCH
  ACCEPT
}

ON OFF {
  SET isOn 0
  GOTO SWITCH
  ACCEPT
}

ON SPELLCAST {
  IF (^SENDER != PLAYER) ACCEPT

  IF (^$PARAM1 == lightning_strike) {
    SET lightningWasCast 1
  } ELSE {
    IF (^$PARAM1 == DOUSE) {
      SENDEVENT OFF SELF ""
    }
    SET lightningWasCast 0
  }

  ACCEPT
}

ON HIT {
  IF (^$PARAM2 == "spell") {
    IF (lightningWasCast == 1) {
      SENDEVENT ON SELF ""
    }
  }
  ACCEPT
}

>>SWITCH {
  if (isOn == oldIsOn) {
    ACCEPT
  }

  SET oldIsOn isOn

  if (isOn == 1) {
    SPELLCAST -smfx 1 IGNIT self // [s] = no anim, [m] = no draw, [f] = no mana required, [x] = no sound
    PLAY "fluorescent-lamp-startup"
    PLAY -lip "fluorescent-lamp-hum" // [l] = loop, [i] = unique, [p] = variable pitch
    TIMERon -m 1 1500 GOSUB TURN_ON

    SET #BURNOUT_TIMER ~^RND_120~
    INC #BURNOUT_TIMER 30
    RANDOM 85 TIMERautooff 1 ~#BURNOUT_TIMER~ SENDEVENT OFF SELF ""
  } else {
    SPELLCAST -smfx 1 DOUSE self
    TIMERoff -m 1 500 GOSUB TURN_OFF
  }

  ACCEPT
}

>>TURN_ON {
  TWEAK SKIN "[stone]_ground_caves_wet05" "backrooms-[metal]-light-on"
  PLAY "fluorescent-lamp-plink"
  RETURN
}

>>TURN_OFF {
  TWEAK SKIN "[stone]_ground_caves_wet05" "backrooms-[metal]-light-off"
  PLAY -s "fluorescent-lamp-hum" // [s] = stop (only if unique)
  RETURN
}